<div class="full-width full-height flex-column neutral-background-color">
  <div [attr.data-test-toolbar-id]="'requirement-toolbar'">
    <div class="m-5 font-20-px flex-fixed-size flex-row">
      <span>
        <i
          nz-icon
          nz-dropdown
          [nzDropdownMenu]="creationMenu"
          nzType="sqtm-core-tree:add"
          nzTheme="outline"
          [ngClass]="
            (creationMenuButtonActivation$ | async)
              ? 'current-workspace-button action-icon-size'
              : 'label-color action-icon-size'
          "
          [attr.data-test-toolbar-button-id]="'create-button'"
        ></i>
      </span>
      <sqtm-core-toggle-icon
        class="m-l-30"
        [attr.data-test-toolbar-button-id]="'copy-button'"
        [active]="tree.canCopy$ | async"
        (clickedInActiveMode)="copy()"
      >
        <i
          nz-icon
          nzType="sqtm-core-generic:copy"
          nzTheme="outline"
          nz-tooltip
          [nzTooltipTitle]="'sqtm-core.generic.label.copy' | translate"
          nzTooltipPlacement="bottom"
          class="action-icon-size"
        ></i>
      </sqtm-core-toggle-icon>
      <sqtm-core-toggle-icon
        class="m-l-10"
        [attr.data-test-toolbar-button-id]="'paste-button'"
        [active]="tree.canPaste$ | async"
        (click)="paste()"
      >
        <i
          nz-icon
          nzType="sqtm-core-generic:paste"
          nzTheme="outline"
          nz-tooltip
          class="action-icon-size"
          [nzTooltipTitle]="
            'sqtm-core.generic.label.paste-with-shortcut' | translate
          "
          nzTooltipPlacement="bottom"
        ></i>
      </sqtm-core-toggle-icon>

      @if (referentialDataService.canDeleteFromFront$ | async) {
        <sqtm-core-toggle-icon
          class="m-l-10"
          [attr.data-test-toolbar-button-id]="'delete-button'"
          [active]="tree.canDelete$ | async"
          (clickedInActiveMode)="delete()"
        >
          <i
            nz-icon
            nzType="sqtm-core-generic:delete"
            nzTheme="outline"
            nz-tooltip
            class="action-icon-size"
            [nzTooltipTitle]="
              'sqtm-core.generic.label.delete-with-shortcut' | translate
            "
            nzTooltipPlacement="bottom"
          ></i>
        </sqtm-core-toggle-icon>
      }
      <span class="m-l-auto">
        <i
          nz-icon
          nzType="sqtm-core-tree:import_export"
          nzTheme="outline"
          nz-dropdown
          [nzDropdownMenu]="importExportMenu"
          [ngClass]="
            (batchMenuButtonActivation$ | async)
              ? 'current-workspace-button action-icon-size'
              : 'label-color action-icon-size'
          "
          [attr.data-test-toolbar-button-id]="'import-export'"
        ></i>
      </span>
      <span class="m-l-10">
        <i
          nz-icon
          nzType="sqtm-core-generic:settings"
          nzTheme="outline"
          nz-popover
          [nzPopoverContent]="settingsMenu"
          class="current-workspace-button action-icon-size"
          [attr.data-test-toolbar-button-id]="'settings-button'"
        ></i>
      </span>
      <span class="m-l-10 m-r-20" (click)="navigateToSearch()">
        <i
          nz-icon
          nzType="sqtm-core-tree:search"
          nzTheme="outline"
          class="current-workspace-button action-icon-size"
          nz-tooltip
          [nzTooltipTitle]="'sqtm-core.generic.label.research' | translate"
          [attr.data-test-toolbar-button-id]="'research-button'"
        ></i>
      </span>
    </div>
    <div
      class="parent-milestone-container-state"
      [attr.data-test-element-id]="'parent-milestone-container-state'"
    >
      @if (
        this.referentialDataService.milestoneModeData$ | async;
        as milestoneState
      ) {
        @if (
          milestoneState.milestoneModeEnabled &&
          milestoneState.milestoneFeatureEnabled
        ) {
          <ng-container class="m-l-30">
            <div
              class="milestone-container-state"
              nz-dropdown
              [nzDropdownMenu]="milestoneMenu"
              [nzPlacement]="'bottomCenter'"
            >
              <i
                nz-icon
                nzType="sqtm-core-nav:milestone"
                class="m-l-2 current-workspace-button action-icon-size"
                [attr.data-test-toolbar-button-id]="'milestone-button'"
              ></i>
              <span>
                {{ milestoneState.selectedMilestone.label }}
              </span>
            </div>
          </ng-container>
        }
      }
    </div>
  </div>
  <div class="full-width full-height" sqtmCoreTreeKeyboardShortcut>
    <sqtm-core-grid
      class="sqtm-core-prevent-selection-in-grid"
    ></sqtm-core-grid>
  </div>
</div>

<ng-template #settingsMenu>
  <div [attr.data-test-menu-id]="'settings'">
    <span class="current-workspace-main-color sqtm-tree-configuration-title">
      <div
        style="display: flex; justify-content: center"
        [attr.data-test-menu-id]="'collapse'"
      >
        <button
          nz-button
          nzType="primary"
          [attr.data-test-menu-item-id]="'collapse-tree'"
          [disabled]="!(canBeCollapsed$ | async)"
          (click)="collapseTree()"
        >
          {{ 'sqtm-core.tree-picker.generic.collapse-tree.label' | translate }}
        </button>
      </div>
    </span>
    <div class="spacer m-b-10"></div>
    <span class="current-workspace-main-color sqtm-tree-configuration-title">
      {{ 'sqtm-core.tree-picker.generic.sort.label' | translate }}
    </span>
    <div [attr.data-test-menu-id]="'sort-menu'">
      <nz-radio-group [(ngModel)]="sortValue" (ngModelChange)="changeSort()">
        <label
          nz-radio
          nzValue="ALPHABETICAL"
          [attr.data-test-menu-item-id]="'sort-alphabetical'"
          >{{
            'sqtm-core.tree-picker.generic.sort.alphabetic' | translate
          }}</label
        >
        <label
          nz-radio
          nzValue="POSITIONAL"
          [attr.data-test-menu-item-id]="'sort-positional'"
          >{{
            'sqtm-core.tree-picker.generic.sort.positional' | translate
          }}</label
        >
      </nz-radio-group>
    </div>
    <div class="spacer m-b-10"></div>
    <span class="current-workspace-main-color sqtm-tree-configuration-title">
      {{
        'sqtm-core.tree-picker.generic.configuration.truncate-too-long-names.title'
          | translate
      }}
    </span>
    <div [attr.data-test-menu-id]="'truncate-menu'">
      <nz-radio-group
        [(ngModel)]="truncateNameValue"
        (ngModelChange)="changeEllipsisDirection()"
      >
        <label
          nz-radio
          nzValue="TO-THE-RIGHT"
          [attr.data-test-menu-item-id]="'truncate-to-the-right'"
          >{{
            'sqtm-core.tree-picker.generic.configuration.truncate-too-long-names.to-the-right'
              | translate
          }}</label
        >
        <label
          nz-radio
          nzValue="TO-THE-LEFT"
          [attr.data-test-menu-item-id]="'truncate-to-the-left'"
          >{{
            'sqtm-core.tree-picker.generic.configuration.truncate-too-long-names.to-the-left'
              | translate
          }}</label
        >
      </nz-radio-group>
    </div>
  </div>
</ng-template>

<nz-dropdown-menu #milestoneMenu="nzDropdownMenu">
  <ul nz-menu [attr.data-test-menu-id]="'milestone-menu'">
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'change-active-milestone'"
      (click)="openMilestoneSelect()"
    >
      {{ 'sqtm-core.dialog.milestone.picker.other-single' | translate }}
    </li>
    <li
      nz-menu-item
      [attr.data-test-menu-item-id]="'show-active-milestone-dashboard'"
      (click)="navigateToMilestoneDashboard()"
    >
      {{ 'sqtm-core.tree-picker.generic.milestone.dashboard' | translate }}
    </li>
  </ul>
</nz-dropdown-menu>

<nz-dropdown-menu #creationMenu="nzDropdownMenu">
  @if (creationMenuPermissions$ | async; as creationMenuPermissions) {
    <ul nz-menu [attr.data-test-menu-id]="'create-menu'">
      <li
        nz-menu-item
        [attr.data-test-menu-item-id]="'new-requirement'"
        [nzDisabled]="!creationMenuPermissions.canCreateRequirement"
        (click)="openCreateRequirement()"
      >
        {{
          'sqtm-core.requirement-workspace.tree.button.new-requirement'
            | translate
        }}
      </li>
      <li
        nz-menu-item
        [attr.data-test-menu-item-id]="'new-high-level-requirement'"
        [nzDisabled]="!creationMenuPermissions.canCreateHighLevelRequirement"
        (click)="openCreateHighLevelRequirement()"
      >
        {{
          'sqtm-core.requirement-workspace.tree.button.new-high-level-requirement'
            | translate
        }}
      </li>
      <li
        nz-menu-item
        [attr.data-test-menu-item-id]="'new-folder'"
        [nzDisabled]="!creationMenuPermissions.canCreateFolder"
        (click)="openCreateFolder()"
      >
        {{ 'sqtm-core.test-case-workspace.tree.button.new-folder' | translate }}
      </li>
    </ul>
  }
</nz-dropdown-menu>

<nz-dropdown-menu #importExportMenu="nzDropdownMenu">
  @if (batchMenuPermissions$ | async; as batchMenuPermissions) {
    <ul nz-menu [attr.data-test-menu-id]="'import-export-menu'">
      <li
        nz-menu-item
        [attr.data-test-menu-item-id]="'import-requirement'"
        [nzDisabled]="!batchMenuPermissions.canImport"
        (click)="import()"
      >
        {{ 'sqtm-core.generic.label.import' | translate }}
      </li>
      <li
        nz-menu-item
        [attr.data-test-menu-item-id]="'export-requirement'"
        [nzDisabled]="!batchMenuPermissions.canExport"
        (click)="export()"
      >
        {{ 'sqtm-core.generic.label.export' | translate }}
      </li>
      @for (wizardMenuItem of wizardMenuItems$ | async; track wizardMenuItem) {
        <li
          nz-menu-item
          [nzDisabled]="!wizardMenuItem.enabled"
          (click)="openSyncDialog(wizardMenuItem)"
        >
          {{ wizardMenuItem.wizardMenu.label }}
        </li>
      }
    </ul>
  }
</nz-dropdown-menu>
